#!/usr/bin/env python3
"""
GISAS of cylinders on a 2D square paracrystal.

The paracrystal is isotropic (integration over xi), with a Cauchy
probability distribution function and 10 nm spacing.
Compare with Paracrystal.py which uses a non-square BasicLattice2D.
"""
import bornagain as ba
from bornagain import ba_plot as bp, deg, nm


def get_sample():
    particle_color = (0.86, 0.24, 0.18)
    particle_mat = ba.RefractiveMaterial("Particle", particle_color, 6e-4, 2e-8)
    substrate_color = (0.28, 0.57, 0.82)
    substrate_mat = ba.RefractiveMaterial("Substrate", substrate_color, 6e-6, 2e-8)
    vacuum = ba.Vacuum()

    ff = ba.Cylinder(5 * nm, 5 * nm)
    particle = ba.Particle(particle_mat, ff)

    lattice = ba.SquareLattice2D(10 * nm, 0)
    structure = ba.Paracrystal2D(particle, lattice, 0, 0, 0)
    structure.setIntegrationOverXi(True)
    structure.setDomainSizes(20e3 * nm, 20e3 * nm)
    profile = ba.Profile2DCauchy(80 * nm, 80 * nm, 0)
    structure.setProbabilityDistributions(profile, profile)

    vacuum_layer = ba.Layer(vacuum)
    substrate_layer = ba.Layer(substrate_mat)
    vacuum_layer.deposit2D(structure)

    sample = ba.Sample()
    sample.addLayer(vacuum_layer)
    sample.addLayer(substrate_layer)
    return sample


def get_simulation(sample):
    beam = ba.Beam(1e9, 0.1*nm, 0.2*deg)
    n = 200
    detector = ba.SphericalDetector(n, -2*deg, 2*deg, n, 0, 2*deg)
    simulation = ba.ScatteringSimulation(beam, sample, detector)
    return simulation


if __name__ == '__main__':
    sample = get_sample()
    ba.showSample3D(sample, sample_size=300*nm, seed=0)
    simulation = get_simulation(sample)
    result = simulation.simulate()
    bp.plot_datafield(result, unit_aspect=1)
    bp.plt.show()
